<?php
/**
 *
 * @author  ahrasis http://smf.ahrasis.com
 * @license BSD http://opensource.org/licenses/BSD-3-Clause
 * @mod     ROAM - Re-Organized Admin Menu
 *
 */

if (!defined('SMF')) 
	die('Hacking attempt...');

function ROAM_Buttons(&$admin_areas)
{
	global $txt, $modSettings;

	if (!empty($modSettings['roam_enable'])) {

		// Load language(s)
		loadLanguage('ROAM');

		// Pull Reports To Main Section
		if (isset($admin_areas['maintenance']['areas']['mailqueue']))
			$admin_areas['forum']['areas']['mailqueue'] = $admin_areas['maintenance']['areas']['mailqueue'];
		unset($admin_areas['maintenance']['areas']['mailqueue']);
		if (isset($admin_areas['maintenance']['areas']['reports']))
			$admin_areas['forum']['areas']['reports'] = $admin_areas['maintenance']['areas']['reports'];
		unset($admin_areas['maintenance']['areas']['reports']);
		
		// Configuration is Modification
		$admin_areas['config']['title'] = $txt['admin_config_rename'];
		
		// Pull Sub
		if (isset($admin_areas['forum']['areas']['packages']))
			$admin_areas['config']['areas']['packages'] = $admin_areas['forum']['areas']['packages'];
		unset($admin_areas['forum']['areas']['packages']);
		if (isset($admin_areas['members']['areas']['sengines']))
			$admin_areas['config']['areas']['sengines'] = $admin_areas['members']['areas']['sengines'];
		unset($admin_areas['members']['areas']['sengines']);

		// Create Modification Section
		$modification = array(
			'modification' => array(
				'title' => $txt['roam_mod_title'],
				'permission' => array('admin_forum'),
				'areas' => array(
					'featuresettings' => $admin_areas['config']['areas']['featuresettings'],
					'securitysettings' => $admin_areas['config']['areas']['securitysettings'],
					'languages' => $admin_areas['config']['areas']['languages'],
					'serversettings' => $admin_areas['config']['areas']['serversettings'],
				)
			)
		);

		// Then we make two pieces, and insert ours in between the two.
		$first = array_slice($admin_areas, 0, 2);
		$second = array_slice($admin_areas, 2);
		$admin_areas = array_merge($first, $modification, $second);
		
		// Now Unset The One That We Moved
		unset($admin_areas['config']['areas']['featuresettings']);
		unset($admin_areas['config']['areas']['securitysettings']);
		unset($admin_areas['config']['areas']['languages']);
		unset($admin_areas['config']['areas']['serversettings']);
		
		// Create Theme Section
		$theme = array(
			'theme' => array(
				'title' => $txt['roam_theme_title'],
				'permission' => array('admin_forum'),
				'areas' => array(
					'current_theme' => $admin_areas['config']['areas']['current_theme'],
					'theme' => $admin_areas['config']['areas']['theme'],
					'smileys' => $admin_areas['layout']['areas']['smileys'],
					'manageattachments' => $admin_areas['layout']['areas']['manageattachments'],
				)
			)
		);
		
		// Then we make two pieces, and insert ours in between the two.
		$third = array_slice($admin_areas, 0, 3);
		$fourth = array_slice($admin_areas, 3);
		$admin_areas = array_merge($third, $theme, $fourth);

		// Now Unset The One That We Moved
		unset($admin_areas['config']['areas']['current_theme']);
		unset($admin_areas['config']['areas']['theme']);
		unset($admin_areas['layout']['areas']['smileys']);
		unset($admin_areas['layout']['areas']['manageattachments']);

		// Pull Reports To Main Section
		if (isset($admin_areas['members']['areas']['permissions']))
			$admin_areas['maintenance']['areas']['permissions'] = $admin_areas['members']['areas']['permissions'];
		unset($admin_areas['members']['areas']['permissions']);
	}
}

function ROAM_Settings(&$config_vars)
{
	// Load language(s)
	loadLanguage('ROAM');
	// Add setting(s)
	$roam = array(
			'',
			array('check', 'roam_enable'),
	);
	// Insert after all available slice.
	$first = array_slice($config_vars, 0);
	$config_vars = array_merge($first, $roam);
}
?>